
{PureInt unit created by Pas2Int (c) 1998 by Thomas Mueller}
{&PureInt+,SmartLink+}

unit uTWMStringS;

{&use32+}

// this unit should be compatible with H+ and H-

interface

uses
  SysUtils;

type
  Str80=string[80];
  Asc255=array[0..255] of char;

procedure Error_(Desc: string);

// Str <-> Decimal conversion
function isDecDigit_(a: char): boolean;
function isDec(const _s: string): boolean;
function DecDigit2Long_(a: char): LongInt;
function Dec2Long(const _s: string): LongInt;
function Long2Dec2_(l: LongInt): string;
function Long2Dec4_(l: LongInt): string;
function Long2DecN_(l: LongInt; _n: byte): string;
function Long2Dec_(l: LongInt): string;

// Str <-> Hex conversion
function isHexDigit_(a: char): boolean;
function isHex(const _s: string): boolean;
function HexDigit2Long_(a: char): LongInt;
function Long2Hex_(l: LongInt): string;
function Hex2Long(const _s: string): LongInt;

// Str <-> any numeric system conversion
function isDigit_(a: char; _Base: byte): boolean;
function isNumber(const _s: string; _Base: byte): boolean;
function Num2Long(const _s: string; _Base: byte): LongInt;
function Long2Num_(l: LongInt; _Base: byte): string;
function isNumberN(const _s: string; _Base: byte): word;

function GetDelStr(var _Zeile: string; _Del: char): string;

function LoCase_(c: char): char;
// function UpStr(const _s: string): string; // use SysUtils.(Ansi)UpperCase instead
// function LoStr(const _s: string): string; // use SysUtils.(Ansi)LowerCase instead

function SpaceStr_(Anz: word): string;
function StringOf_(c: char; _Anz: word): string;

function AddBackslash(const _s: string): string;
function StripBackslash(const _s: string): string;
function ForceExtension(const _Name, _Ext: string): string;
function JustFilename(const _Name: string): string;

function RPadStr(const _s: string; _Len: word): string;
function LPadStr(const _s: string; _Len: word): string;
// function RTrimStr(const _s: string): string; // use SysUtils.TrimRight instead
// function LTrimStr(const _s: string): string; // use SysUtils.TrimLeft instead
// function TrimStr(const _s: string): string;  // use SysUtils.Trim instead

function RPosStr_(Sub, _s: string): word;

function Str2Pas_(p: pChar): string;
function StrPNew_(s: string): pChar;
function Pas2Str(var s: string): pChar;

procedure StrReadLn(var _f: file; _p: pChar);
procedure StrReadZ(var _f: file; _p: pChar);

function MatchStr(const _Searched, _Match: string): boolean;
function UMatchStr(const _Searched, _Match: string): boolean;

function LDotDotStr(const _s: string; _MaxLen: word): string;
function RDotDotStr(const _s: string; _MaxLen: word): string;
function CenterStr(const _s: string; _MaxLen: word): string;

function LeftStr(const _s: string; _Len: word): string;
function RightStr(const _s: string; _Len: word): string;
function TailStr(const _s: string; _Start: word): string;

function PosStr(const _SubStr, _s: string; _Start: word): word;

function ExchangeChars(const _s: string; _Search, _Replace: char): string;

function nthWord_(s: string; _Idx: integer; _WhiteSpace: string): string;
function nthCharOf(const _s: string; _n: word): Char;

implementation

end.
